*** app_queue.c.ORIG	2003-11-19 15:56:45.000000000 -0600
--- app_queue.c	2004-01-18 14:55:39.000000000 -0600
***************
*** 76,81 ****
--- 76,82 ----
  "      'd' -- data-quality (modem) call (minimum delay).\n"
  "      'H' -- allow caller to hang up by hitting *.\n"
  "      'n' -- no retries on the timeout; will exit this application and go to the next step.\n"
+ "      'r' -- present a ringing tone instead of music on hold.\n"
  "  In addition to transferring the call, a call may be parked and then picked\n"
  "up by another user.\n"
  "  The optionnal URL will be sent to the called party if the channel supports\n"
***************
*** 119,124 ****
--- 120,126 ----
  	int ringbackonly;
  	int musiconhold;
  	int dataquality;
+ 	int ringingonly;
  	int allowdisconnect;
  	struct member *member;
  	struct localuser *next;
***************
*** 728,733 ****
--- 730,736 ----
  		}
  		memset(tmp, 0, sizeof(struct localuser));
  		tmp->stillgoing = -1;
+ 		tmp->ringingonly = 0;
  		if (options) {
  			if (strchr(options, 't'))
  				tmp->allowredirect_in = 1;
***************
*** 741,746 ****
--- 744,751 ----
  				tmp->dataquality = 1;
  			if (strchr(options, 'H'))
  				tmp->allowdisconnect = 1;
+ 			if (strchr(options, 'r'))
+ 				tmp->ringingonly = 1;
  			if (strchr(options, 'n'))
  				go_on = 1;
  		}
***************
*** 813,818 ****
--- 818,824 ----
  		update_queue(qe->parent, lpeer);
  		hanguptree(outgoing, peer);
  		/* Stop music on hold */
+ 		ast_indicate(qe->chan, -1);
  		ast_moh_stop(qe->chan);
  		outgoing = NULL;
  		if (announce) {
***************
*** 1139,1145 ****
  	qe.start = time(NULL);
  	if (!join_queue(queuename, &qe)) {
  		/* Start music on hold */
! 		ast_moh_start(chan, qe.moh);
  		for (;;) {
  			res = wait_our_turn(&qe);
  			/* If they hungup, return immediately */
--- 1145,1154 ----
  	qe.start = time(NULL);
  	if (!join_queue(queuename, &qe)) {
  		/* Start music on hold */
! 		if (u->ringingonly) 	/* to allow ringing sound instead of MOH */
! 			ast_indicate(chan, AST_CONTROL_RINGING);
! 		else
! 			ast_moh_start(chan, qe.moh);
  		for (;;) {
  			res = wait_our_turn(&qe);
  			/* If they hungup, return immediately */
***************
*** 1180,1185 ****
--- 1189,1195 ----
  		/* Don't allow return code > 0 */
  		if (res > 0 && res != AST_PBX_KEEPALIVE) {
  			res = 0;	
+ 			ast_indicate(chan, -1);
  			ast_moh_stop(chan);
  		}
  		leave_queue(&qe);
